var Structr = require('structr'),
Bindable = require('malt/bindable');






var View = Bindable.extend({
	
	/**
	 */


	'__construct': function(ops)
	{
		this.el = ops.el;

		this._q = new Instructions(this);

		this._children = [];
	},

	/**
	 */

	'addChild': function(child)
	{
		this._children.push(child);
	},

	/**
	 */

	'init': function(listen)
	{
		this.on(listen);

		this._q.add.apply(this._q, this._instructions());

		return this;
	},


	/**
	 * internal
	 */

	'render': function(next)
	{
		next();
	},

	/**
	 */

	'renderChildren': function(next)
	{
		var nChildren = this._child
	},
	

	/**
	 */

	'finish': function()
	{
		this.change('finish');
	},


	/**
	 */

	'_instructions': function()
	{
		return [  'render', 'renderChildren' ];
	}
});

var ItemView = exports.ItemView = View.extend({
	
	/**
	 */

	'override __construct': function(ops)
	{
		this._super(ops);
		
		this.data = ops.data;	
	},

	/**
	 */

	'data': function(v)
	{
		if(!arguments.length) return this._data;

		this.emit('data', v);

		this._data = v;

		this.initData(v);
	},

	/**
	 */

	'initData': function(v)
	{
		
	},

	/**
	 */

	'load': function()
	{
		
	},

	/** 
	 * updates the view 
	 */

	'update': function()
	{
		
	},


	/**
	 */

	'_instructions': function()
	{
		//render, *then* load. Shouldn't have to wait until stuff is finished - it just feels faster this way.
		//data is also dynamic, unlike the rendered view
		return this._super().concat('load');
	}

});


var CollectionView = exports.Collection = ItemView.extend({
	
	/**
	 */

	'initData': function(data)
	{
		//init
	}

});


var TemplateViewPartial = {
	
	/**
	 */

	'override __construct': function(ops)
	{
		this._super(ops);

		this.tpl = ops.tpl;
	},

	/**
	 */

	'init': function()
	{
		var self = this;
		this.data().router.pull('template', { name: this.tpl }, { meta: { cache: 1 }}, function(content)
		{
			//handle template here....

			self.render();
		});

		return this;
	}
};



exports.ItemTemplate = ItemView.extend(TemplateViewPartial);
exports.CollectionTemplate = CollectionView.extend(TemplateViewPartial);



/**


new View().init({
	loaded: 
})

*/